int Rpm;
int RpmLight;
int Gear;
int GearLight = 0;

char kind_of_data;

int latchpin = 8; // connect to pin 12 on the '595
int clockpin = 12; // connect to pin 11 on the '595
int datapin = 11; // connect to pin 14 on the '595


void setup(){

  pinMode(latchpin, OUTPUT);
  pinMode(clockpin, OUTPUT);
  pinMode(datapin, OUTPUT);

  Serial.begin(115200);
}

void loop(){ 
  //****************************** READ DATA FROM SERIAL ******************************
  while (Serial.available() > 0)
  {

    kind_of_data = Serial.read();
    if (kind_of_data == 'G' ) Read_Gear();
    if (kind_of_data == 'R' ) Read_Rpm();

    digitalWrite(latchpin, LOW);
    shiftOut(datapin, clockpin, MSBFIRST, GearLight);
    shiftOut(datapin, clockpin, LSBFIRST, RpmLight);
    digitalWrite(latchpin, HIGH);
  }
}


//****************************** READ DATA FROM SERIAL END ******************************

void Read_Gear(){

  int Gear = 0;
  delay(2);
  int Gear100 = Serial.read();
  delay(2);
  int Gear10 = Serial.read();
  delay(2);
  int Gear1= Serial.read();

  Gear100 = ((Gear100)-48)*100;
  Gear10  = ((Gear10)-48)*10;
  Gear1   = ((Gear1)-48)*1;
  if (Gear10 < 0 && Gear1 < 0){
    Gear100 = Gear100/100;
    Gear10 = 0;
    Gear1 = 0;
  }
  if (Gear < 0){
    Gear100 = Gear100/10;
    Gear10 = Gear10/10;
    Gear1 = 0;
  }

  Gear = Gear100+Gear10+Gear1;

  if (Gear < 127) {
    GearLight = 80;
  } //r  - little r
  if (Gear == 127) {
    GearLight = 84;
  } //n - little n
  if (Gear == 149) {
    GearLight = 6;
  } //1
  if (Gear == 170)  {
    GearLight = 91;
  }   //2
  if (Gear == 191) {
    GearLight = 79;
  } //3
  if (Gear == 213) {
    GearLight = 102;
  } // 4
  if (Gear == 234) { 
    GearLight = 109;
  }// 5
  if (Gear == 255) {
    GearLight = 124;
  }// 6 

}

void Read_Rpm(){

  int Rpm = 0;
  delay(2);
  int Rpm100 = Serial.read();
  delay(2);
  int Rpm10 = Serial.read();
  delay(2);
  int Rpm1= Serial.read();

  Rpm100 = ((Rpm100)-48)*100;
  Rpm10  = ((Rpm10)-48)*10;
  Rpm1   = ((Rpm1)-48)*1;
  if (Rpm10 < 0 && Rpm1 < 0){
    Rpm100 = Rpm100/100;
    Rpm10 = 0;
    Rpm1 = 0;
  }
  if (Rpm1 < 0){
    Rpm100 = Rpm100/10;
    Rpm10 = Rpm10/10;
    Rpm1 = 0;
  }

  Rpm = Rpm100+Rpm10+Rpm1;


  if (Rpm > 108) { 
    RpmLight = 0;
  }  
  if (Rpm > 0 && Rpm <= 16){ 
    RpmLight = 255;
  }
  if (Rpm > 16 && Rpm <= 32){ 
    RpmLight = 254;
  }
  if (Rpm > 32 && Rpm <= 48){ 
    RpmLight = 252;
  }
  if (Rpm > 48 && Rpm <= 54){ 
    RpmLight = 248;
  }
  if (Rpm > 54  && Rpm <= 60){ 
    RpmLight = 240;
  }
  if (Rpm > 60 && Rpm <= 76) { 
    RpmLight = 224;
  }
  if (Rpm > 76 && Rpm <= 92) { 
    RpmLight = 192;
  }
  if (Rpm > 92 && Rpm <= 108) { 
    RpmLight = 128;
  }
}




